using System;
using System.Runtime.InteropServices;
using System.IO;
using System.Text;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Linq;

namespace VeryDocTestApp
{
  public class XpsConverter
	{
    public XpsConverter()
    {
    }
    
    [DllImport("pdf2vec.dll", EntryPoint = "VeryPDF_PDF2Vector", SetLastError = true,
       CharSet = CharSet.Ansi, ExactSpelling = true,
       CallingConvention = CallingConvention.StdCall)]
    public static extern int VeryPDF_PDF2Vector(string strCommandLine);

    public byte[] ConvertPdfToXps(byte[] pdfBytes)
    {
      byte[] xpsBytes = null;

      string pdfFullFilePath = System.IO.Path.GetTempFileName();
      string xpsFullFilePath = pdfFullFilePath.Substring(0, pdfFullFilePath.Length - 3) + "xps";
      // Save PDF byte array to random filename
      using (FileStream stream = File.Create(pdfFullFilePath, pdfBytes.Length))
      {
        stream.Write(pdfBytes, 0, pdfBytes.Length);
      }

      // Convert PDF file to XPS file using dll
      string PdfToXpsCommand = @"pdf2vec ""-$"" ""XXXXXXXXXXXXXXXXXXXX"" ";
      //string PdfToXpsCommandArgs = pdfFullFilePath + " " + xpsFullFilePath;
      string PdfToXpsCommandArgs = @"""" + pdfFullFilePath + @""" """ + xpsFullFilePath + @"""";
      System.Diagnostics.Debug.WriteLine(String.Format("command line: {0}", PdfToXpsCommand + PdfToXpsCommandArgs));
      int nRet = VeryPDF_PDF2Vector(PdfToXpsCommand + PdfToXpsCommandArgs);

      string appPath = System.IO.Path.GetDirectoryName(System.Reflection.Assembly.GetEntryAssembly().Location);
      string strXPSFile = appPath + @"\" + System.IO.Path.GetRandomFileName() + @".xps";
      System.IO.File.Copy(xpsFullFilePath, strXPSFile);

      // Load XPS file to byte array
      FileInfo xpsFileInfo = new FileInfo(xpsFullFilePath);
      long numBytes = xpsFileInfo.Length;
      using (FileStream fStream = new FileStream(xpsFullFilePath, FileMode.Open, FileAccess.Read))
      {
        using (BinaryReader br = new BinaryReader(fStream))
        {
          xpsBytes = br.ReadBytes((int)numBytes);
        }
      }

      // Delete XPS file & PDF file
      FileInfo pdfFileInfo = new FileInfo(pdfFullFilePath);
      if (pdfFileInfo.Exists)
      {
        File.Delete(pdfFullFilePath);
      }
      if (xpsFileInfo.Exists)
      {
        File.Delete(xpsFullFilePath);
      }

      return xpsBytes;
    }
  }
}
